/******************************************************************/
// Enable Restart (from Gravity Guy)- v.1.0                       */
// by Bruno Godefroy aka Nitrosax - 2014                          */
//                                                                */
// Thanks to all contributors (can't remember the names sorry ^^) */
/******************************************************************/

// Just include "enableRestart.h" and call "APP_EnableRestart();" at the end of the execution.

#include "syscall.h"
#include "enableRestart.h"

int OSVersionAsInt( void ){
	unsigned char mainversion;
	unsigned char minorversion;
	unsigned short release;
	unsigned short build;
	GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
	return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}

short*APP_EnableRestart(){
	unsigned int ea;
	unsigned int j;
	short*pEnableRestartFlag;
	if ( OSVersionAsInt() < 0x02020000 ){
	ea = *(unsigned int*)0x8001007C;
	ea += 0x0490*4;
	ea = *(unsigned int*)( ea );
	j = *(unsigned char*)( ea + 1 );
	j *= 4;
	j = ( ea + j + 4 ) & 0xFFFFFFFC;
	pEnableRestartFlag = (short*)(*( unsigned int*)( j ) + 8 );
	}else{
	pEnableRestartFlag = 0;
	}
	if ( pEnableRestartFlag ) *pEnableRestartFlag = 1;
	return pEnableRestartFlag;
}